////////////////////////////////////////////////////////////////////////////////////////////
// copy the files from this folder inside your \work folder
// don't forget to include flamethrow.wdl
// place a model in your level and attach it the "flame_thrower" action
////////////////////////////////////////////////////////////////////////////////////////////

function create_flames();
function fade_flames();
function particle_flames();

////////////////////////////////////////////////////////////////////////////////////////////

bmap fire_tga = <fire.tga>;

////////////////////////////////////////////////////////////////////////////////////////////

sound gotflames_wav = <gotflames.wav>;

////////////////////////////////////////////////////////////////////////////////////////////

var flame_range = 400; // the flames can go up to 400 quants in front of the player
var flame_start[3];
var flame_end[3];

////////////////////////////////////////////////////////////////////////////////////////////

action flame_thrower
{
	my.metal = on;
	while (player == null) {wait (1);} // wait until the player is loaded
	while (vec_dist (my.x, player.x) > 60) // wait until the player has come close enough
	{
		my.pan += 5 * time;
		wait (1);
	}
	snd_play(gotflames_wav, 60, 0);
	my.passable = on;
	while (1)
	{
		/*my.x = player.x + 20 * cos(player.pan) + 13 * sin(player.pan); // place the weapon 20 quants in front of the player
		my.y = player.y + 20 * sin(player.pan) - 13 * cos(player.pan); // 13 quants to the right
		my.z = player.z + 12; // and 12 quants above player's origin
		my.pan = camera.pan;
		my.tilt = camera.tilt;*/
		vec_for_vertex (flame_start, my, 630); // the flames will start at the coordinates given by the 14th vertex on the gun
		vec_set(flame_end, nullvector); // reset flame_end
		flame_end.x = flame_range.x; // add 400 quants to it
		vec_rotate(flame_end, player.pan); // rotate it depending on player's angles
		vec_add(flame_end.x, player.x); // now set the correct flame_end position in 1st person mode (use player.x instead of camera.x for 3rd person)
		if (mouse_left == 1) || (key_ctrl == on) // Ctrl was pressed?
		{
			create_flames(); // fire!
		}
		wait (1);
	}
} 

function create_flames()
{
	vec_sub(flame_end.x, flame_start.x);
	temp = vec_length(flame_end);
	flame_end.x = (flame_end.x * 3) / temp;
	flame_end.y = (flame_end.y * 3) / temp;
	flame_end.z = (flame_end.z * 3) / temp;
	while(temp > 0)
	{
		effect(particle_flames, 1, flame_start.x, nullvector);
		vec_add(flame_start.x, flame_end.x);
		temp -= 3;
	}
}

function particle_flames()
{
	temp.x = random(2) - 1;
	temp.y = random(2) - 1;
	temp.z = random(2) - 1;
	vec_set(my.vel_x, temp);
	my.move = on;
	my.bmap = fire_tga;
	my.flare = on;
	my.bright = on;
	my.alpha = 100;
	my.lifespan = 100;
	my.size = 15;
	my.function = fade_flames;
}

function fade_flames()
{
	my.alpha -= 75 * time;
	my.size += 10 * time;
	if(my.alpha < 0) {my.lifespan = 0;}
}
